#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#include "math/Vec2f.h"

#define SCREEN_WIDTH    600
#define SCREEN_HEIGHT   600

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Metaballs 2", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    Vec2f   blobPos(SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2);
    float   blobRadius = 100.0f;

    while (sys.isQuitRequested() == false)
    {
        for (int y = 0; y < SCREEN_HEIGHT; y++)
            for (int x = 0; x < SCREEN_HEIGHT; x++)
            {
                Vec2f p(x, y);
                Vec2f delta = p - blobPos;
                float dist = blobRadius - delta.mag();

                if (dist < 0)
                    dist = 0;

                if (dist > 255)
                    dist = 255;

                int c = (int)dist;
                gfx.setPixel(x, y, Color(c, c, c));
            }

        gfx.render();
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
